#include "CXBOXController.h"



CXBOXController::CXBOXController(int playerNumber)
{
	// Set the Controller Number
	_controllerNum = playerNumber - 1;
}

XINPUT_STATE CXBOXController::GetState()
{
	// Zeroise the state
	ZeroMemory(&_controllerState, sizeof(XINPUT_STATE));

	// Get the state
	XInputGetState(_controllerNum, &_controllerState);

	return _controllerState;
}

bool CXBOXController::IsConnected()
{
	// Zeroise the state
	ZeroMemory(&_controllerState, sizeof(XINPUT_STATE));

	// Get the state
	DWORD Result = XInputGetState(_controllerNum, &_controllerState);

	if(Result == ERROR_SUCCESS)
	{
		return true;
	}
	else
	{
		return false;
	}
}

void CXBOXController::Vibrate(int leftVal, int rightVal)
{
	// Create a Vibraton State
	XINPUT_VIBRATION Vibration;

	// Zeroise the Vibration
	ZeroMemory(&Vibration, sizeof(XINPUT_VIBRATION));

	// Set the Vibration Values
	Vibration.wLeftMotorSpeed = leftVal;
	Vibration.wRightMotorSpeed = rightVal;

	// Vibrate the controller
	XInputSetState(_controllerNum, &Vibration);
}

#define n_keys 8
int past_state_keys[n_keys];
int keys[n_keys];

CXBOXController* Player1;
void xcon_create()
{
	for(int i = 0; i < n_keys; i++)
	{
		keys[i] = 0;
	}
	for(int i = 0; i < n_keys; i++)
	{
		past_state_keys[i] = 0;
	}
	Player1 = new CXBOXController(1);
}
void xcon_update()
{
	for(int i = 0; i < n_keys; i++)
	{
		past_state_keys[i] = keys[i];
		keys[i] = 0;
	}


	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_A)
		keys[xcon_key_a] = 1;
	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_B)
		keys[xcon_key_b] = 1;
	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_X)
		keys[xcon_key_x] = 1;
	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_Y)
		keys[xcon_key_y] = 1;

	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP)
		keys[xcon_dpad_up] = 1;
	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN)
		keys[xcon_dpad_down] = 1;
	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT)
		keys[xcon_dpad_left] = 1;
	if(Player1->GetState().Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT)
		keys[xcon_dpad_right] = 1;
}

void xcon_destroy()
{
	delete(Player1);
}

int xcon_is_key_pressed(controller_keys key)
{
	if(past_state_keys[key] == 0 && keys[key] == 1)
		return 1;
	else
		return 0;
}

int xcon_is_key_released(controller_keys key)
{
	if(past_state_keys[key] == 1 && keys[key] == 0)
		return 1;
	else
		return 0;
}

int xcon_is_key_active(controller_keys key)
{
	return keys[key];
}