#include "Header.h"
#include "Log.h"

#define qtd_fundo 5

extern int mapvet[];
extern int mapsize;

extern unsigned int fonte32;
extern unsigned int fonte64;
extern unsigned int botao_jogar;
extern unsigned int botao_ajuda;
extern unsigned int botao_creditos;
extern unsigned int botao_menu;
extern unsigned int botao_voltar;
extern unsigned int botao_sair;
extern unsigned int spmira;//Ponteiro do mouse
extern unsigned int titulo;
extern unsigned int pause;
extern unsigned int win;
extern unsigned int Sprites_Fundo[6];

extern unsigned int musicas[2];
extern unsigned int sons[2];//efeitos sonoros do jogo...
extern unsigned int objetos_sprites[6];
extern Componente *personagens;
extern Componente *fundo;
extern Componente *mapa;
extern Componente *Monstros;
extern Componente *Objetos;
extern unsigned int textura_gato[12];
extern ArquivoLog *Log;

bool CarregaRecursos()
{
	personagens[0].loadSprite=C2D2_CarregaSpriteSet("./graficos/player_novo.png",573,672);
	personagens[1].loadSprite=C2D2_CarregaSpriteSet("./graficos/player2_novo.png",573,672);
	personagens[2].loadSprite=C2D2_CarregaSpriteSet("./graficos/player_novo.png",573,672);
	Monstros[0].loadSprite = C2D2_CarregaSpriteSet("./graficos/monstro_novo.png",573,672);
	Monstros[1].loadSprite = C2D2_CarregaSpriteSet("./graficos/monstro_novo.png",573,672);
	Monstros[2].loadSprite = C2D2_CarregaSpriteSet("./graficos/monstro_novo.png",573,672);
	Sprites_Fundo[0] = C2D2_CarregaSpriteSet("./graficos/fundo/fase1/fundo0.png",496,1000);
	Sprites_Fundo[1] = C2D2_CarregaSpriteSet("./graficos/fundo/fase1/fundo1.png",496,1000);
	Sprites_Fundo[2] = C2D2_CarregaSpriteSet("./graficos/fundo/fase1/fundo2.png",496,1000);
	Sprites_Fundo[3] = C2D2_CarregaSpriteSet("./graficos/fundo/fase1/fundo3.png",496,1000);
	Sprites_Fundo[4] = C2D2_CarregaSpriteSet("./graficos/fundo/fase1/fundo4.png",496,1000);
	Objetos[0].loadSprite = C2D2_CarregaSpriteSet("./graficos/fundo/outros/portao.png",200,1000);
	Objetos[1].loadSprite = C2D2_CarregaSpriteSet("./graficos/fundo/outros/MEDALHA.png",251,236);

	musicas[0]=CA2_CarregaMusica("./sons/musica.mp3");
	musicas[1]=CA2_CarregaMusica("./sons/jogo_musica.mp3");

	for(int I = 0; I<mapsize; I++){
		char back[100];
		sprintf(back,"./graficos/fundo/fundo%d.png",mapvet[I]);
		mapa[I].loadSprite=C2D2_CarregaSpriteSet(back,496,1000);
	}
	for(int ii=qtd_fundo-1;ii>=0;ii--){
		fundo[ii] = mapa[ii];
		fundo[ii].loadSprite = mapa[ii].loadSprite;
	}

    fonte32 = C2D2_CarregaFonte("./graficos/fontes/Leelawadee32.bmp", 32);
    if(fonte32==0)
    {
		LogInfo(Log, "Failed to load the font size 32.");
        return false;
    }
    C2D2_TrocaCorLimpezaTela(0,0,255);
    C2D2_LimpaTela();
    C2D2_DesenhaTexto(fonte32, 400, 284, "Loading resources, please wait.", C2D2_TEXTO_CENTRALIZADO);
	C2D2_Sincroniza(C2D2_FPS_PADRAO);
    fonte64 = C2D2_CarregaFonte("./graficos/fontes/CourierNew64.bmp", 64);
    if(fonte64==0)
    {
		LogInfo(Log, "Failed to load the font size 64.");
        return false;
    }
    botao_jogar = C2D2_CarregaSpriteSet("./graficos/botao_jogar.png", 200, 40);
    if(botao_jogar==0)
    {
		LogInfo(Log, "Failed to load the play button.");
        return false;
    }
	botao_ajuda = C2D2_CarregaSpriteSet("./graficos/botao_ajuda.png", 200, 40);
    if(botao_ajuda==0)
    {
		LogInfo(Log, "Failed to load the help button.");
        return false;
    }
	botao_menu = C2D2_CarregaSpriteSet("./graficos/botao_menu.png", 200, 40);
    if(botao_menu==0)
    {
		LogInfo(Log, "Failed to load the menu button.");
        return false;
    }
    botao_creditos = C2D2_CarregaSpriteSet("./graficos/botao_creditos.png", 200, 40);
    if(botao_creditos==0)
    {
		LogInfo(Log, "Failed to load the credit button.");
        return false;
    }
    botao_sair = C2D2_CarregaSpriteSet("./graficos/botao_sair.png", 200, 40);
    if(botao_sair==0)
    {
		LogInfo(Log, "Failed to load the quit button.");
        return false;
    }
    botao_voltar = C2D2_CarregaSpriteSet("./graficos/botao_voltar.png", 200, 40);
    if(botao_voltar==0)
    {
		LogInfo(Log, "Failed to load the back button.");
        return false;
    }
    spmira = C2D2_CarregaSpriteSet("./graficos/mouse.png", 12, 18);
    if(spmira==0)
    {
		LogInfo(Log, "Failed to load the mouse sprite");
        return false;
    }
    titulo = C2D2_CarregaSpriteSet("./graficos/titulo.jpg", 0, 0);
    if(titulo==0)
    {
		LogInfo(Log, "Failed to load the start screen.");
        return false;
    }
	win = C2D2_CarregaSpriteSet("./graficos/you_win.png", 0, 0);
    if(win==0)
    {
		LogInfo(Log, "Failed to load the victory screen.");
        return false;
    }
	pause = C2D2_CarregaSpriteSet("./graficos/pause.png", 0, 0);
    if(pause==0)
    {
		LogInfo(Log, "Failed to load the pause screen.");
        return false;
    }
    return true;
}